"""autogenerated by genmsg_py from GPUStatus.msg. Do not edit."""
import roslib.message
import struct

import std_msgs.msg

class GPUStatus(roslib.message.Message):
  _md5sum = "4c74e5474b8aade04e56108262099c6e"
  _type = "pr2_msgs/GPUStatus"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """Header header
string product_name
string pci_device_id
string pci_location
string display
string driver_version
float32 temperature # Temperature in Celcius
float32 fan_speed # Fan speed in rad/s
float32 gpu_usage # Usage in percent
float32 memory_usage # Usage in percent
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"""
  __slots__ = ['header','product_name','pci_device_id','pci_location','display','driver_version','temperature','fan_speed','gpu_usage','memory_usage']
  _slot_types = ['Header','string','string','string','string','string','float32','float32','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       header,product_name,pci_device_id,pci_location,display,driver_version,temperature,fan_speed,gpu_usage,memory_usage
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(GPUStatus, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg._Header.Header()
      if self.product_name is None:
        self.product_name = ''
      if self.pci_device_id is None:
        self.pci_device_id = ''
      if self.pci_location is None:
        self.pci_location = ''
      if self.display is None:
        self.display = ''
      if self.driver_version is None:
        self.driver_version = ''
      if self.temperature is None:
        self.temperature = 0.
      if self.fan_speed is None:
        self.fan_speed = 0.
      if self.gpu_usage is None:
        self.gpu_usage = 0.
      if self.memory_usage is None:
        self.memory_usage = 0.
    else:
      self.header = std_msgs.msg._Header.Header()
      self.product_name = ''
      self.pci_device_id = ''
      self.pci_location = ''
      self.display = ''
      self.driver_version = ''
      self.temperature = 0.
      self.fan_speed = 0.
      self.gpu_usage = 0.
      self.memory_usage = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.product_name
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.pci_device_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.pci_location
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.display
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.driver_version
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_4f.pack(_x.temperature, _x.fan_speed, _x.gpu_usage, _x.memory_usage))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg._Header.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.product_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.pci_device_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.pci_location = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.display = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.driver_version = str[start:end]
      _x = self
      start = end
      end += 16
      (_x.temperature, _x.fan_speed, _x.gpu_usage, _x.memory_usage,) = _struct_4f.unpack(str[start:end])
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.product_name
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.pci_device_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.pci_location
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.display
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.driver_version
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_4f.pack(_x.temperature, _x.fan_speed, _x.gpu_usage, _x.memory_usage))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg._Header.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.product_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.pci_device_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.pci_location = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.display = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.driver_version = str[start:end]
      _x = self
      start = end
      end += 16
      (_x.temperature, _x.fan_speed, _x.gpu_usage, _x.memory_usage,) = _struct_4f.unpack(str[start:end])
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_4f = struct.Struct("<4f")
_struct_3I = struct.Struct("<3I")
