"""autogenerated by genmsg_py from PowerState.msg. Do not edit."""
import roslib.message
import struct

import roslib.rostime
import std_msgs.msg

class PowerState(roslib.message.Message):
  _md5sum = "e6fa46a387cad0b7a80959a21587a6c9"
  _type = "pr2_msgs/PowerState"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# This message communicates the state of the PR2's power system.
Header header
float64 power_consumption ## Watts
duration time_remaining ## estimated time to empty or full
string prediction_method ## how time_remaining is being calculated
int8  relative_capacity ## percent of capacity
int8  AC_present ## number of packs detecting AC power, > 0 means plugged in

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"""
  __slots__ = ['header','power_consumption','time_remaining','prediction_method','relative_capacity','AC_present']
  _slot_types = ['Header','float64','duration','string','int8','int8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       header,power_consumption,time_remaining,prediction_method,relative_capacity,AC_present
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(PowerState, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg._Header.Header()
      if self.power_consumption is None:
        self.power_consumption = 0.
      if self.time_remaining is None:
        self.time_remaining = roslib.rostime.Duration()
      if self.prediction_method is None:
        self.prediction_method = ''
      if self.relative_capacity is None:
        self.relative_capacity = 0
      if self.AC_present is None:
        self.AC_present = 0
    else:
      self.header = std_msgs.msg._Header.Header()
      self.power_consumption = 0.
      self.time_remaining = roslib.rostime.Duration()
      self.prediction_method = ''
      self.relative_capacity = 0
      self.AC_present = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_d2i.pack(_x.power_consumption, _x.time_remaining.secs, _x.time_remaining.nsecs))
      _x = self.prediction_method
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2b.pack(_x.relative_capacity, _x.AC_present))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg._Header.Header()
      if self.time_remaining is None:
        self.time_remaining = roslib.rostime.Duration()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 16
      (_x.power_consumption, _x.time_remaining.secs, _x.time_remaining.nsecs,) = _struct_d2i.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.prediction_method = str[start:end]
      _x = self
      start = end
      end += 2
      (_x.relative_capacity, _x.AC_present,) = _struct_2b.unpack(str[start:end])
      self.time_remaining.canon()
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_d2i.pack(_x.power_consumption, _x.time_remaining.secs, _x.time_remaining.nsecs))
      _x = self.prediction_method
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2b.pack(_x.relative_capacity, _x.AC_present))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg._Header.Header()
      if self.time_remaining is None:
        self.time_remaining = roslib.rostime.Duration()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 16
      (_x.power_consumption, _x.time_remaining.secs, _x.time_remaining.nsecs,) = _struct_d2i.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.prediction_method = str[start:end]
      _x = self
      start = end
      end += 2
      (_x.relative_capacity, _x.AC_present,) = _struct_2b.unpack(str[start:end])
      self.time_remaining.canon()
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_d2i = struct.Struct("<d2i")
_struct_3I = struct.Struct("<3I")
_struct_2b = struct.Struct("<2b")
